<?php
session_start();

//بررسی اینکه آیا کاربر در سایت وارد شده است یا نه
//اگر کاربر در سایت وارد شده بود به پروفایلش هدایت شود
if(isset($_SESSION['user_id']) || isset($_COOKIE['user_id'])){
    header("location : /my-account");
} 

include BASE_PATH."/model/Users.php";

$error = [];
//بررسی می کنیم که آیا کاربر فرم را پر کرده و ارسال کرده است؟
if(isset($_POST['register'])) {
    //دریافت اطلاعاتی که کاربر از طریق فرم ارسال کرده است
    $username = $_POST['username'];
    $email = $_POST['email'];
    $password = $_POST['password'];
    $re_password = $_POST['re_password'];

    if(!is_username_valid($username)) {
        $error[] = 'نام کاربری معتبر نیست.';
    }
    if(!filter_var($email, FILTER_VALIDATE_EMAIL)) {
        $error[] = 'ایمیل وارد شده معتبر نیست!';
    }
    if($password != $re_password) {
        $error[] = 'پسورد ها با هم برابر نیستند!';
    }
    if(!is_password_strong($password)) {
        $error[] = 'لطفاً پسورد قوی تری انتخاب کنید.';
    }

    //اگر هیچ خطایی نبود، اطلاعات کاربر در دیتابیس ذخیره شود
    if(empty($error)) {
        $user_id = add_user($username, $email, $password);
        $_SESSION['user_id'] = $user_id;
        setcookie('user_id', $user_id, time() + 30*24*60*60, '/');
        header("location: /my-account");
    }
}

include BASE_PATH."/view/register.php";