<?php

/**
 * از این تابع برای دریافت لیست سفارشات استفاده می شود.
 * اگر پارامتر شناسه کاربر وارد شود، سفارشات مربوط به یک کاربر خاص برداشت می شود
 * @param $args با استفاده از این پارامتر می توانیم لیست سفارشات را فیلتر کرده یا تعداد سفارشات دریافتی را مشخص کنیم
 */
function get_orders($args = null){

    $args = array_merge(get_default_order_args(), $args);
    extract($args); //این تابع تمام اعضای آرایه را به متغیر تبدیل می کند

    $dbc = $GLOBALS['dbc'];
    if($limit) { // اگر صفر نبود، یعنی محدوده ی مشخص درخواست شده است
        $num = "LIMIT $limit OFFSET $offset";
    }
    $where = '';

    if($user_id) {
        $where = 'WHERE user_id = '.$user_id;
    }
    $orders = mysqli_query($dbc, "SELECT * FROM orders $where ORDER BY $sortby $order $num");
    $result = [];
    while($row = mysqli_fetch_array($orders)) {
        $result[] = $row;
    }

    return $result;
}

//تعداد کل سفارشات
function get_all_orders_num($args = null) {
    if(!$args) $args = get_default_order_args();
    extract($args); //این تابع تمام اعضای آرایه را به متغیر تبدیل می کند
    $where = '';

    if($user_id) {
        $where = 'WHERE user_id = '.$user_id;
    }
    $dbc = $GLOBALS['dbc'];
    $orders = mysqli_query($dbc, "SELECT * FROM orders $where");
    return mysqli_num_rows($orders);
}


function get_order($order_id) {
    $dbc = $GLOBALS['dbc'];
  
    $order = mysqli_query($dbc, "SELECT * FROM orders WHERE id = $order_id");
    return mysqli_fetch_array($order);
}


function get_order_products($order_id) {
    $dbc = $GLOBALS['dbc'];
  
    $order_products = mysqli_query($dbc, "SELECT * FROM order_products INNER JOIN products
                                            ON order_products.product_id = products.id WHERE order_id = $order_id");
    $result = [];
    while($row = mysqli_fetch_array($order_products)) {
        $result[] = $row;
    }
    return $result;
}

//ویرایش وضعیت سفارش که در برنامه نویسی پنل مدیریت استفاده می شود
function edit_order_status($status, $order_id) {
    $dbc = $GLOBALS['dbc'];
    mysqli_query($dbc, "UPDATE orders SET status = '$status' WHERE id = $order_id");
}

//حذف سفارش که در برنامه نویسی پنل مدیریت استفاده می شود
function delete_order($order_id) {
    $dbc = $GLOBALS['dbc'];
    mysqli_query($dbc, "DELETE FROM orders WHERE id = $order_id");
}

function get_default_order_args(){
    return [
        'limit' => 20,
        'offset' => 0,
        'sortby' => 'id',
        'order' => 'DESC',
        'user_id' => 0,
    ];
}

function add_order($args) {
    $dbc = $GLOBALS['dbc'];
    $keys = $values = '';
    foreach($args as $key => $value) {
        $keys .= "$key, ";
        $values .= "'$value', ";
    }
    $keys .= "order_date";
    $values .= time();
    mysqli_query($dbc, "INSERT INTO orders ($keys) VALUES ($values)");
    return mysqli_insert_id();
}

function add_order_products($order_id, $cart) {
    $dbc = $GLOBALS['dbc'];
    foreach($cart as $product_id => $quantity) {
        mysqli_query($dbc, "INSERT INTO order_products (order_id,product_id,quantity)
                                                 VALUES ('$order_id', '$product_id', '$quantity')");
    }
    
}