<?php

function get_users($args = null){

    $args = array_merge(get_default_users_args(), $args);
    extract($args); //این تابع تمام اعضای آرایه را به متغیر تبدیل می کند

    $dbc = $GLOBALS['dbc'];
    if($limit) { // اگر صفر نبود، یعنی محدوده ی مشخص درخواست شده است
        $num = "LIMIT $limit OFFSET $offset";
    }
    $users = mysqli_query($dbc, "SELECT * FROM users ORDER BY $sortby $order $num");
    $result = [];
    while($row = mysqli_fetch_array($users)) {
        $result[] = $row;
    }

    return $result;
}

function get_default_users_args(){
    return [
        'limit' => 20,
        'offset' => 0,
        'sortby' => 'id',
        'order' => 'DESC',
    ];
}

//تعداد کل کاربران
function get_all_users_num() {
    $dbc = $GLOBALS['dbc'];
    $users = mysqli_query($dbc, "SELECT * FROM users");
    return mysqli_num_rows($users);
}

function get_user($user_id) {
    $dbc = $GLOBALS['dbc'];
  
    $user = mysqli_query($dbc, "SELECT * FROM users WHERE id = $user_id");
    return mysqli_fetch_array($user);
}


//حذف کاربر که در برنامه نویسی پنل مدیریت استفاده می شود
function delete_user($user_id) {
    $dbc = $GLOBALS['dbc'];
    mysqli_query($dbc, "DELETE FROM users WHERE id = $user_id");
}


function add_user($username, $email, $password) {
    $dbc = $GLOBALS['dbc'];

    $hashed_password = md5($password);
    $user_id = mysqli_query($dbc, "INSERT INTO users (username, email, password, register_date) 
                                            VALUES ('$username', '$email', '$hashed_password')");
    return $user_id;
}

//بررسی معتبر بودن نام کاربری
//می توانید شرایط دلخواه خود را برای نام کاربری تعیین کنید
function is_username_valid($username) {
    if(strlen($username) < 6) { // نام کاربری باید بیشتر از 6 کاراکتر باشد
        return false;
    }
    if(strpos($username, ' ') !== false ){//نام کاربری نباید شامل فاصله خالی باشد
        return false;
    }
    return true;
}

//بررسی اینکه آیا پسورد به اندازه کافی قوی است یا نه
//می توانید شرایط دلخواه خود را برای پسورد تعیین کنید
function is_password_strong($password) {
    if(strlen($password) < 6) { //پسورد باید حتماً بیشتر از 6 حرف باشد
        return false;
    }
    return true;
}

//چک کردن اینکه آیا کاربری با این اطلاعات وجود دارد یا نه
function is_user_exists($username, $password) {
    $dbc = $GLOBALS['dbc'];

    $hashed_password = md5($password);
    $user = mysqli_query($dbc, "SELECT * FROM users WHERE username = '$username' AND password = '$hashed_password'");
    if(mysqli_num_rows($user) > 0) {
        $row = mysqli_fetch_array();
        return $row['id'];
    }
    return false;
}


